#!/usr/bin/awk
#### եܼץ mkidx.awk V2.12 
#### Copyright 1998,1999,2000,2001 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### ƥȺѥåȤFreeBSDΤߡ
#### 
#### History: 
#### 2001/08/07 V2.12 HTMLΥХ</DD></DL>ˡthanks to ޤƤ
#### 2000/09/23 V2.11 

BEGIN {
	Setup();

	if ( ARGC < 2 ) {
		split( strftime( "%Y %m %d", systime() ), today );
		year = today[1];
	} else {
		year = ARGV[1];
	}

	MakeReplaceDatabase( KEEPDIR SLASH REPLACENAME );
	fout = sprintf( NKFCMD " " NKFCODE " " fout ">" PUTDIR SLASH "%04d.html", year );

	print "<HTML>" | fout;
	print "<HEAD>" | fout;
	print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=ISO-2022-JP\">" | fout;
	print "<META HTTP-EQUIV=\"Content-Language\" CONTENT=\"ja\">" | fout;
	print "<!--  -->" | fout;
	printf( "<TITLE>%d index</TITLE></HEAD>\n", year ) | fout;
	print "<BODY>" | fout;
	printf( "<DIV>%04d / ", year ) | fout;
	for ( month=1; month<=12; month++ ) {
		printf( "[<A href=\"#%02d\">%02d</A>] ", month, month ) | fout;
	}
	printf( "[<A href=\"%04d.html\">&lt;&lt; %04d</A>] [<A href=\"%04d.html\">%04d &gt;&gt;</A>]</DIV>\n", year-1, year-1, year+1, year+1 ) | fout;
	print "<TABLE border=\"1\">" | fout;
#	printf( "<TR><TD align=\"center\" colspan=\"4\"><A href=\"%04d.html\">&lt;&lt; %04d</A> [ %04d ] <A href=\"%04d.html\">%04d &gt;&gt;</A></TD></TR>\n", year-1, year-1, year, year+1, year+1 ) | fout;
	printf( "<TR><TD align=\"center\" colspan=\"4\">%04d</TD></TR>\n", year ) | fout;
	for ( y=0; y<3; y++ ) {
		print "<TR>" | fout;
		for ( x=0; x<4; x++ ) {
			month = y*4+x+1;
			printf( "<TD align=\"center\">%d</TD>", month ) | fout;
		}
		print "</TR><TR>" | fout;
		for ( x=0; x<4; x++ ) {
			month = y*4+x+1;
			YMD2DAYS( year, month, 1 );
			print "<TD>" | fout;
			print " <TABLE border=\"0\">" | fout;
			day = 0;
			for ( cy=0; cy<6; cy++ ) {
				print " <TR>" | fout;
				for ( cx=0; cx<7; cx++ ) {
					if ( day == 0 ) {
						if ( cx == WDAY ) {
							day = 1;
						}
					} else {
						if ( day > DAYS[month] ) {
							day = -1;
						}
					}
					part = 0;
					if ( day > 10 ) {
						part++;
					}
					if ( day > 20 ) {
						part++;
					}
					if ( day > 0 ) {
						printf( "<TD align=\"right\"><A href=\"%d%02d%c.html#%02d\">%d</A></TD>", year, month, substr( "abc", part+1, 1 ), day, day ) | fout;
						day++;
					} else {
						printf( "<TD><BR></TD>", day ) | fout;
					}
				}
				print "</TR>" | fout;
			}
			print " </TABLE>" | fout;
			print "</TD>" | fout;
		}
		print "</TR>" | fout;
	}
	print "</TABLE>" | fout;

	print "<P></P>" | fout;
	print "<DD>" | fout;
	for ( month=1; month<=12; month++ ) {
		printf( "<DT><B><A name=\"%02d\">[*]</A> %d/%02d</B>\n", month, year, month ) | fout;
		for ( day=1; day<=DAYS[month]; day++ ) {
			part = 0;
			if ( day > 10 ) {
				part++;
			}
			if ( day > 20 ) {
				part++;
			}
			ntitle = 0;
			topic = "";
			fin = MakeMasterFileName( year, month, day );
			while ( (getline line<fin) > 0 ) {
				if ( sub( /^@topic /, "", line ) ) {
					topic = Replace( line, year, month, part, day );
					continue;
				}
				if ( sub( /^@title /, "", line ) ) {
					title[ntitle++] = Replace( line, year, month, part, day );
					continue;
				}
			}
			if ( ntitle || topic != "" ) {
				printf( "<DD><A href=\"%d%02d%c.html#%02d\">%02d</A> ", year, month, substr( "abc", part+1, 1 ), day, day ) | fout;
				if ( topic != "" ) {
					print "<B>" topic ":</B> " | fout;
				}
				for ( i=0; i<ntitle-1; i++ ) {
					print title[i] " / " | fout;
				}
				print title[i] | fout;
			}
		}
	}
	print "</DL>" | fout;
	print "</BODY>" | fout;
	print "</HTML>" | fout;
}

########################################################################
###  
#
function Setup(       fin )
{
	DIGESTHEADERNAME = "10.html"				# ȥإåե̾ 
	DIGESTPREMEMONAME = "11.html"				# ʸե̾ 
	DIGESTPOSTMEMONAME = "20.html"				# ʸե̾ 
	DIGESTFOOTERNAME = "21.html"				# ȥեåե̾ 
	BASEHEADERNAME = "30.html"					# ١եإåե̾ 
	BASEFOOTERNAME = "40.html"					# ١եեåե̾ 
	ITEMNAME = "98.html"						# ƥե̾ 
	REPLACENAME = "99.html";					# URLִǡ١̾ 
	LASTMODIFIEDFORMAT = "%a, %d %b %Y %H:%M:%S %Z";				# ϥեޥå(@/lastmodified/) 
}

########################################################################
### ޥե֤̾ 
#
function MakeMasterFileName( year, month, date )
{
	return ( sprintf( GETDIR SLASH "%04d" SLASH "%02d%02d.html", year, month, date ) );
}

########################################################################
### URLִǡ١ν 
#
function MakeReplaceDatabase( fin )
{
	FS = "[ \t]+";
	NREPLACE = 0;
	while ( ( getline<fin ) > 0 ) {
		if ( match( $1, "^#" ) ) {
			continue;
		}
		if ( length( $0 ) < 1 ) {
			continue;
		}
		REPLACE_Key[ NREPLACE ] = $1;
		REPLACE_Name[ $1 ] = $2;
		REPLACE_Obj[ $1 ] = $3;
		gsub( "\r", "", REPLACE_Obj[ $1 ] );
		NREPLACE++;
	}
	close( fin );
}

########################################################################
### ִURLִǡ١ˤִ 
#
function Replace( line, year, month, part, date                 , y, m, p, s, i, pt, le, s1, s2, key, name )
{
	if ( !match( line, "@" ) ) {
		return line;
	}
	gsub( "@/lastmodified/", LASTMODIFIED, line );
	s = sprintf( "%04d", year );
	gsub( "@/year/", s, line );
	s = sprintf( "%02d", month );
	gsub( "@/month/", s, line );
	gsub( "@/part/", PARTS[part], line );
	gsub( "@/PART/", part+1, line );

	if ( match( line, "@/prevfile/" ) ) {
		y = year;
		m = month;
		p = part;
		p--;
		if ( p < 0 ) {
			p = 2;
			m--;
			if ( m < 1 ) {
				m = 12;
				y--;
			}
		}
		s = sprintf( "%04d%02d%s.html", y, m, PARTS[p] );
		gsub( "@/prevfile/", s, line );
	}
	if ( match( line, "@/nextfile/" ) ) {
		y = year;
		m = month;
		p = part;
		p++;
		if ( p > 2 ) {
			p = 0;
			m++;
			if ( m > 12 ) {
				m = 1;
				y++;
			}
		}
		s = sprintf( "%04d%02d%s.html", y, m, PARTS[p] );
		gsub( "@/nextfile/", s, line );
	}

	do {
		if ( !match( line, "@[*]" ) ) {
			break;
		}
		FOOTNOTE_REFER++;
		s = sprintf( "<SMALL><A HREF=\"%04d%02d%s.html#%02dF%02d\">%s%d</A></SMALL>", year, month, PARTS[part], date, FOOTNOTE_REFER, FOOTNOTEMARK, FOOTNOTE_REFER );
		sub( "@[*]", s, line );
	} while (!0);

	do {
		pt = match( line, "@/[^/]*/[^/]*/" );
		if ( pt == 0 ) {
			break;
		}
		le = RLENGTH;
		s1 = substr( line, 1, pt-1 );
		s = substr( line, pt, le );
		s2 = substr( line, pt+le, length( line )-pt-le+1 );
# print "["s1"]", "["s"]", "["s2"]";
		key = s;
		sub( "@/", "", key );
		sub( "/[^/]*/", "", key );
# print "["key"]";
		if ( !(key in REPLACE_Name) ) {
# print "No Key [" key "].";
			sub( "@", "\\&#64;", s );
			line = s1 s s2;
			continue;
		}
		name = s;
		sub( "@/[^/]*/", "", name );
		sub( "/", "", name );
# print "["name"]";
		if ( name == "" ) {
			name = REPLACE_Name[key];
		}
		line = s1 "<A HREF=\""REPLACE_Obj[key]"\">"name"</A>" s2;
	} while (!0);

	return line;
}

########################################################################
###  
#
function Setup_DAYS( year )
{
	DAYS[1] = 31;
	DAYS[2] = 28;
	DAYS[3] = 31;
	DAYS[4] = 30;
	DAYS[5] = 31;
	DAYS[6] = 30;
	DAYS[7] = 31;
	DAYS[8] = 31;
	DAYS[9] = 30;
	DAYS[10] = 31;
	DAYS[11] = 30;
	DAYS[12] = 31;
	if ( (((year%4) == 0) && ((year%100) != 0)) || ((year%400) == 0) ) {
		DAYS[2] = 29;
	}
}

########################################################################
### ǯ 
#
function Setup_DAYS1( year )
{
	DAYS1 = 365;
	if ( (((year%4) == 0) && ((year%100) != 0)) || ((year%400) == 0) ) {
		DAYS1++;
	}
}

########################################################################
### ǯ1980/01/01ѻաפ 
#
function YMD2DAYS( year, month, date       ,days, i )
{
	if ( date < 1 ) {
		error_arg("date<1");
	}
	Setup_DAYS( year );
	days = DAYS[month];
	if ( date > days ) {
		error_arg("date>end " date ">" days);
	}

	TOTALDAYS = 0;
	for ( i=1980; i<year; i++ ) {
		Setup_DAYS1( i );
		TOTALDAYS += DAYS1;
	}
	for ( i=1; i<month; i++ ) {
		TOTALDAYS += DAYS[i];
	}
	TOTALDAYS += date-1;

	WDAY = (TOTALDAYS+2) % 7;  # SUN->SAT 
}

########################################################################
### 1980/01/01ѻաפǯ 
#
function DAYS2YMD( totaldays )
{
	WDAY = (TOTALDAYS+2) % 7;  # SUN->SAT 

	for ( YEAR=1980; YEAR<2100; YEAR++ ) {
		Setup_DAYS1( YEAR );
		if ( DAYS1 > totaldays ) {
			break;
		}
		totaldays -= DAYS1;
	}

	Setup_DAYS( YEAR );
	for ( MONTH=1; MONTH<=12; MONTH++ ) {
		if ( DAYS[MONTH] > totaldays ) {
			break;
		}
		totaldays -= DAYS[MONTH];
	}

	DATE = totaldays+1;
}

function error_arg(s)
{
	print "error_arg " s;
	exit;
}

# [EOF]
